<?php
/*
Plugin Name: Sidebar Tabs
Plugin URI: http://www.nghorta.com/plugin-sidebartabs
Description: sidebarTabs allows you to easily widgets into Tabs
Author: Newton Horta
Version: 1.1.2
Author URI: http://www.nghorta.com

    sidebarTabs is released under the GNU General Public License (GPL)
    http://www.gnu.org/licenses/gpl.txt

	Utiliza parte das instrues do plugin postTabs de autoria de Leo Germani (http://pirex.com.br/wordpress-plugins/post-tabs)
    
*/

if (!is_admin()) add_action('widgets_init','hide_widgets'); 

function hide_widgets() {
	$stab = get_option("sidebarTabs_widget");
	if ($stab != NULL) {
		foreach ($stab as $i => $widget ) {
			if ($widget['unregister'] == 1) {
				if (function_exists(unregister_sidebar_widget)) unregister_sidebar_widget($widget['widget']);
				$pos = strpos($widget['widget'],'text');
				if (!($pos===false)) {
					 remove_action('sidebar_admin_setup','wp_widget_text_setup');
					 remove_action('sidebar_admin_page','wp_widget_text_page');
				}
				$pos = strpos($widget['widget'],'RSS');
				if (!($pos===false)) {
					 remove_action('sidebar_admin_setup','wp_widget_rss_setup');
					 remove_action('sidebar_admin_page','wp_widget_rss_page');
				}
			}	
		}
    }
}

function sidebarTabs_init($reset=false){
	if(!get_option("sidebarTabs") || $reset){

		# Load default options
		$options["active_font"] = "#ffffff";
		$options["active_bg"] = "#464646";
		$options["inactive_font"] = "#464646";
		$options["inactive_bg"] = "#969696";
		$options["over_font"] = "#333333";
		$options["over_bg"] = "#e6e7e8";
		$options["line"] = "none";
		$options["width_sidebar"] = "200";
		$options["unit"] = "px";
		$options["bg_panes"] = "#464646";
		$options["color_links"] = "#c1c1c1";
		$options["color_hover_links"] = "#e18364";
		$options["text_color"] = "#ffffff";
		$options["jQuery"] = "0";
		update_option("sidebarTabs", $options);

		$sidebartabs_args = array(
					'before_widget' => "<div id='%1\$s' class='widget %2\$s'>",
					'after_widget' => '</div>',
					'before_title' => "<h2 class='widgettitle widget_title'>",
					'after_title' => "</h2>",
				); 
		update_option('sidebartabs_args', $sidebartabs_args);
	}

}


add_action('init', 'sidebarTabs_textdomain');
function sidebarTabs_textdomain() {
	load_plugin_textdomain('sidebartabs', false, dirname( plugin_basename(__FILE__) ) . '/langs');
}

function get_sidebarTabs($args) {
	global $wp_registered_widgets, $wp_registered_sidebars, $sidebars_widgets;
	
	$op = '';
	$stab = get_option("sidebartabs_widget");
	$options = get_option("sidebarTabs");
	$widget_options = get_option("widget_sidebarTabs");
	
	if (is_admin()) { 
		$class = $widget_options['classname_admin'];
		if (!$widget_options['exclude']) $op .= '<h2 class="'.$class.'">' . $widget_options['title'] . '</h2>';
	}	
	else {
		$class = $widget_options['classname'];	
		extract($args);
		if (!$widget_options['exclude']) $op .= $before_title . $widget_options['title'] . $after_title;
	}

//	$sidebar = $wp_registered_sidebars['sidebar-1'];

	#Print the sidebartabs links
	
	$op .= "\n<div id='sb_container'>\n";
	$op .= "   <a class='prev'></a>\n";
	$op .= "   <div class='scrollable'>\n";

	$op .= "      <ul id='sidebarTabs_ul' class='sidebarTabs'>\n";

	if (is_array($stab)) { 
		ksort($stab);
		foreach ($stab as $i => $widget ) {
			$op .= '        <li><a href="#tab'.$i.'">'.$widget['sidebartabname']."</a></li>\n";
		}		
	}
	$op .= "      </ul>\n";
	$op .= "   </div>\n<a class='next'></a>\n";
	$op .= '   <div class="sidebarTabs_divs sidebarTabs_panes">'."\n";
	if (is_array($stab)) { 
		ksort($stab);
		foreach ($stab as $i => $widget ) {
			$op .= '      <div class="tb">'."\n";

			$bw = stripslashes($widget['before_widget']);
			$aw = stripslashes($widget['after_widget']);
			$bt = stripslashes($widget['before_title']);
			$at = stripslashes($widget['after_title']);

//			register_sidebar(array(
//				'before_widget' => $bw,
//				'after_widget' => $aw,
//				'before_title' => $bt,
//				'after_title' => $at
//			));

			$widget_registered = $wp_registered_widgets[$widget['widget']];
			$params = array_merge(
				array( array_merge( array('widget_id' => $widget['widget'], 'widget_name' => $wp_registered_widgets[$widget['widget']]['name']) ) ),
				(array) $wp_registered_widgets[$widget['widget']]['params']
			);
			// Substitute HTML id and class attributes into before_widget
			$classname_ = '';
			foreach ((array)$widget_registered['classname'] as $cn) {
				if (is_string($cn)) $classname_ .= '_' . $cn;
				elseif (is_object($cn)) $classname_ .= '_' . get_class($cn);
			}
			$classname_ = strtolower(ltrim($classname_, '_'));
            $params[0]['before_widget'] = sprintf($bw, $widget['widget'], $classname_);
			$params[0]['after_widget'] = $aw;
			$params[0]['before_title'] = $bt;
			$params[0]['after_title'] = $at;
			$check_widget = $widget['widget'];
			$check_widget = split('-', $check_widget);
			if (isset($check_widget[1]) && is_numeric($check_widget[1])) $params[0]['number'] = $check_widget[1];
			ob_start();
				if ( is_callable( $widget['callback'] ) ) {
					call_user_func_array($widget['callback'], $params);
					$content = ob_get_contents();
				}
			ob_end_clean();
			$op .= $content;
			$op .= "      \n</div>\n\n";
		}
	}	
	$op .= "   </div>\n</div>\n";
	echo $op;
}

function sidebarTabs_addHeader(){
	echo "\n".'<!-- Start Of Script Generated By sidebarTabs -->'."\n";
	$sbto=get_option("sidebarTabs");
	$style = "<link rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') . "/wp-content/plugins/sidebartabs/styleSidebar.php?active_bg=".$sbto['active_bg']."&amp;line=".$sbto['line']."&amp;inactive_bg=".$sbto['inactive_bg']."&amp;active_font=".$sbto['active_font']."&amp;inactive_font=".$sbto['inactive_font']."&amp;over_font=".$sbto['over_font']."&amp;over_bg=".$sbto['over_bg']."&amp;width_sidebar=".$sbto['width_sidebar']."&amp;unit=".$sbto['unit']."&amp;bg_panes=".$sbto['bg_panes']."&amp;color_links=".$sbto['color_links']."&amp;color_hover_links=".$sbto['color_hover_links']."&amp;text_color=".$sbto['text_color']."&amp;theme=".get_template()."\" type=\"text/css\" media=\"screen\" />\n";
	$style = str_replace('#','',$style);
   	echo $style;
	if ($sbto["jQuery"]) {
		$sidebar_jquery = '<script src="'. get_settings('home') . '/wp-content/plugins/sidebartabs/js/jquery-1.3.2.min.js" type="text/javascript"></script>';
		echo $sidebar_jquery . "\n";
	}
	?>
	<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/jquery.tools.min.js"></script>	
	<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/sidebarTabs.js"></script>
	<?php
	echo '<!-- End Of Script Generated By sidebarTabs -->'."\n";
}

add_action('admin_enqueue_scripts', 'sidebarTabs_admin_addHeader');

function sidebarTabs_admin_addHeader($hook_suffix){
	$sidebarTabs_hook_suffix = array('sidebartabs/sidebarTabs_admin.php','sidebartabs/sidebarTabs.php', 'settings_page_sidebarTabs');
	if(in_array($hook_suffix, $sidebarTabs_hook_suffix)) {
		$sb_options=get_option("sidebarTabs");
		$style = "<link rel=\"stylesheet\" href=\"" . get_bloginfo('wpurl') . "/wp-content/plugins/sidebartabs/styleSidebar_admin.php?active_bg=".$sb_options['active_bg']."&amp;line=".$sb_options['line']."&amp;inactive_bg=".$sb_options['inactive_bg']."&amp;active_font=".$sb_options['active_font']."&amp;inactive_font=".$sb_options['inactive_font']."&amp;over_font=".$sb_options['over_font']."&amp;over_bg=".$sb_options['over_bg']."&amp;url_list=".get_bloginfo('wpurl')."&amp;bg_panes=".$sb_options['bg_panes']."&amp;text_color=".$sbto['text_color']."\" type=\"text/css\" media=\"screen\" />\n";
		$style = str_replace('#','',$style);
		echo $style;
		?>
		<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/301a.js"></script>
		<script type="text/javascript" src="<?php bloginfo('wpurl'); ?>/wp-content/plugins/sidebartabs/js/jquery-1.3.2.min.js"></script>	
		<?php
	}
}

function sidebarTabs_admin() {
	if (function_exists('add_options_page')) {
		add_options_page('sidebarTabs Options', 'sidebarTabs', 8, basename(__FILE__), 'sidebarTabs_admin_page');
	}
}

function sidebarTabs_admin_page() {
	
	require_once("sidebarTabs_admin.php");

}

function registerWidgets() {
	register_sidebar_widget(array('sidebarTabs', 'widgets'), 'get_sidebarTabs'); 
	register_widget_control(array('sidebarTabs', 'widgets'), 'widget_sidebarTabs_control', 300, 200);
}

function widget_sidebarTabs_control() {
	// Get options
	$options = get_option('widget_sidebarTabs');
	// options exist? if not set defaults
	if ( !is_array($options) )
		$options = array('title'=>'sidebarTabs Title','exclude'=>'0', 'classname_admin'=>'title_sidebarTabs_admin');
	
	// form posted?
	if ( $_POST['sidebarTabs-submit'] ) {

		// Remember to sanitize and format use input appropriately.
		$options['title'] = strip_tags(stripslashes($_POST['sidebarTabs-title']));
		$options['exclude'] = isset($_POST['sidebarTabs-exclude']);
		$options['classname_admin'] = 'title_sidebarTabs_admin';
		update_option('widget_sidebarTabs', $options);
	}

	// Get options for form fields to show
	$title = htmlspecialchars($options['title'], ENT_QUOTES);
	$classname = htmlspecialchars($options['classname'], ENT_QUOTES);
	$exclude = (bool) $options['exclude'];
	
	// The form fields
?>
	<p><label for="sidebarTabs-title"><?php echo __('Title:') ?>
			<input style="width: 240px;" class="widefat" id="sidebarTabs-title" name="sidebarTabs-title" type="text" value="<?php echo $title; ?>" />
		</label></p>
			<br id="clear" />
	<br id="clear" /><br />
	<p style="text-align: left;">
			<label for="sidebarTabs-exclude"><?php echo __('Exclude Title:'); ?>
			<input class="checkbox" id="sidebarTabs-exclude" name="sidebarTabs-exclude" type="checkbox" value="<?php echo $exclude; ?>" <?php echo checked( $exclude, true ); ?> />
			</label></p><br id="clear" />		
	        <input type="hidden" id="sidebarTabs-submit" name="sidebarTabs-submit" value="1" />
<?php
}

register_activation_hook( __FILE__, 'sidebarTabs_init' );

add_action('plugins_loaded', 'registerWidgets');

add_action('wp_head','sidebarTabs_addHeader');
add_action('admin_menu','sidebarTabs_admin');
?>
